package sun.text.bidi;

import java.util.Arrays;
import java.text.Bidi;

public final class BidiLine
{
    public BidiLine() {
    }
    
    static void setTrailingWSStart(BidiBase bidiBase) {
        byte[] dirProps = bidiBase.dirProps;
        byte[] levels = bidiBase.levels;
        int length = bidiBase.length;
        int paraLevel = bidiBase.paraLevel;
        if (BidiBase.NoContextRTL(dirProps[length - 1]) == 7) {
            bidiBase.trailingWSStart = length;
            return;
        }
        while (length > 0 && (BidiBase.DirPropFlagNC(dirProps[length - 1]) & BidiBase.MASK_WS) != 0x0) {
            --length;
        }
        while (length > 0 && levels[length - 1] == paraLevel) {
            --length;
        }
        bidiBase.trailingWSStart = length;
        return;
    }
    
    public static Bidi setLine(Bidi bidi, BidiBase paraBidi, Bidi bidi2, BidiBase trailingWSStart, int i, int n) {
        BidiBase bidiBase3;
        BidiBase bidiBase2;
        BidiBase bidiBase;
        trailingWSStart = (bidiBase = (bidiBase2 = (bidiBase3 = trailingWSStart)));
        int length = n - i;
        bidiBase.resultLength = length;
        bidiBase2.originalLength = length;
        bidiBase3.length = length;
        int trailingWSStart2 = length;
        trailingWSStart.text = new char[trailingWSStart2];
        System.arraycopy(paraBidi.text, i, trailingWSStart.text, 0, trailingWSStart2);
        trailingWSStart.paraLevel = paraBidi.GetParaLevelAt(i);
        trailingWSStart.paraCount = paraBidi.paraCount;
        trailingWSStart.runs = new BidiRun[0];
        if (paraBidi.controlCount > 0) {
            BidiBase bidiBase4;
            for (; i < n; ++i) {
                if (BidiBase.IsBidiControlChar((int)paraBidi.text[i])) {
                    bidiBase4 = trailingWSStart;
                    ++bidiBase4.controlCount;
                }
            }
            BidiBase bidiBase5 = trailingWSStart;
            bidiBase5.resultLength -= trailingWSStart.controlCount;
        }
        trailingWSStart.getDirPropsMemory(trailingWSStart2);
        trailingWSStart.dirProps = trailingWSStart.dirPropsMemory;
        System.arraycopy(paraBidi.dirProps, i, trailingWSStart.dirProps, 0, trailingWSStart2);
        trailingWSStart.getLevelsMemory(trailingWSStart2);
        trailingWSStart.levels = trailingWSStart.levelsMemory;
        System.arraycopy(paraBidi.levels, i, trailingWSStart.levels, 0, trailingWSStart2);
        trailingWSStart.runCount = -1;
        if (paraBidi.direction != 2) {
            trailingWSStart.direction = paraBidi.direction;
            if (paraBidi.trailingWSStart <= i) {
                trailingWSStart.trailingWSStart = 0;
            }
            else if (paraBidi.trailingWSStart < n) {
                trailingWSStart.trailingWSStart = paraBidi.trailingWSStart - i;
            }
            else {
                trailingWSStart.trailingWSStart = trailingWSStart2;
            }
        }
        else {
            byte[] levels = trailingWSStart.levels;
            setTrailingWSStart(trailingWSStart);
            int trailingWSStart3 = trailingWSStart.trailingWSStart;
            Label_0413: {
                if (trailingWSStart3 == 0) {
                    trailingWSStart.direction = (byte)(trailingWSStart.paraLevel & 0x1);
                }
                else {
                    int direction = (byte)(levels[0] & 0x1);
                    if (trailingWSStart3 < trailingWSStart2 && (trailingWSStart.paraLevel & 0x1) != direction) {
                        trailingWSStart.direction = 2;
                    }
                    else {
                        int j = 1;
                        while (j != trailingWSStart3) {
                            if ((levels[j] & 0x1) != direction) {
                                trailingWSStart.direction = 2;
                                break Label_0413;
                            }
                            ++j;
                        }
                        trailingWSStart.direction = direction;
                    }
                }
            }
            switch (trailingWSStart.direction) {
                case 0: {
                    trailingWSStart.paraLevel = (byte)(trailingWSStart.paraLevel + 1 & 0xFFFFFFFE);
                    trailingWSStart.trailingWSStart = 0;
                    break;
                }
                case 1: {
                    BidiBase bidiBase6 = trailingWSStart;
                    bidiBase6.paraLevel |= 0x1;
                    trailingWSStart.trailingWSStart = 0;
                    break;
                }
            }
        }
        trailingWSStart.paraBidi = paraBidi;
        return bidi2;
    }
    
    static byte getLevelAt(BidiBase bidiBase, int n) {
        if (bidiBase.direction != 2 || n >= bidiBase.trailingWSStart) {
            return bidiBase.GetParaLevelAt(n);
        }
        return bidiBase.levels[n];
    }
    
    static byte[] getLevels(BidiBase bidiBase) {
        int trailingWSStart = bidiBase.trailingWSStart;
        int length = bidiBase.length;
        if (trailingWSStart != length) {
            Arrays.fill(bidiBase.levels, trailingWSStart, length, bidiBase.paraLevel);
            bidiBase.trailingWSStart = length;
        }
        if (length < bidiBase.levels.length) {
            byte[] array = new byte[length];
            System.arraycopy(bidiBase.levels, 0, array, 0, length);
            return array;
        }
        return bidiBase.levels;
    }
    
    static BidiRun getLogicalRun(BidiBase bidiBase, int n) {
        BidiRun bidiRun = new BidiRun();
        getRuns(bidiBase);
        int runCount = bidiBase.runCount;
        int limit = 0;
        int limit2 = 0;
        BidiRun bidiRun2 = bidiBase.runs[0];
        int i = 0;
        while (i < runCount) {
            bidiRun2 = bidiBase.runs[i];
            limit2 = bidiRun2.start + bidiRun2.limit - limit;
            if (n >= bidiRun2.start && n < limit2) {
                break;
            }
            limit = bidiRun2.limit;
            ++i;
        }
        bidiRun.start = bidiRun2.start;
        bidiRun.limit = limit2;
        bidiRun.level = bidiRun2.level;
        return bidiRun;
    }
    
    private static void getSingleRun(BidiBase bidiBase, byte b) {
        bidiBase.runs = bidiBase.simpleRuns;
        bidiBase.runCount = 1;
        bidiBase.runs[0] = new BidiRun(0, bidiBase.length, b);
    }
    
    private static void reorderLine(BidiBase bidiBase, byte b, byte b2) {
        if (b2 <= (b | 0x1)) {
            return;
        }
        int n = (byte)(b + 1);
        BidiRun[] runs = bidiBase.runs;
        byte[] levels = bidiBase.levels;
        int runCount = bidiBase.runCount;
        if (bidiBase.trailingWSStart < bidiBase.length) {
            --runCount;
        }
        while (true) {
            --b2;
            if (b2 >= n) {
                int i = 0;
                while (true) {
                    if (i < runCount && levels[runs[i].start] < b2) {
                        ++i;
                    }
                    else {
                        if (i >= runCount) {
                            break;
                        }
                        while (++i < runCount && levels[runs[i].start] >= b2) {}
                        for (int n2 = i - 1; i < n2; ++i, --n2) {
                            BidiRun bidiRun = runs[i];
                            runs[i] = runs[n2];
                            runs[n2] = bidiRun;
                        }
                        if (i == runCount) {
                            break;
                        }
                        ++i;
                    }
                }
            }
            else {
                break;
            }
        }
        if ((n & 0x1) == 0x0) {
            int j = 0;
            if (bidiBase.trailingWSStart == bidiBase.length) {
                --runCount;
            }
            while (j < runCount) {
                BidiRun bidiRun2 = runs[j];
                runs[j] = runs[runCount];
                runs[runCount] = bidiRun2;
                ++j;
                --runCount;
            }
        }
        return;
    }
    
    static int getRunFromLogicalIndex(BidiBase bidiBase, int n) {
        BidiRun[] runs = bidiBase.runs;
        int runCount = bidiBase.runCount;
        int n2 = 0;
        int i = 0;
        while (i < runCount) {
            int n3 = runs[i].limit - n2;
            int start = runs[i].start;
            if (n >= start && n < start + n3) {
                return i;
            }
            n2 += n3;
            ++i;
        }
        throw new IllegalStateException("Internal ICU error in getRunFromLogicalIndex");
    }
    
    static void getRuns(BidiBase bidiBase) {
        if (bidiBase.runCount >= 0) {
            return;
        }
        if (bidiBase.direction != 2) {
            getSingleRun(bidiBase, bidiBase.paraLevel);
        }
        else {
            int length = bidiBase.length;
            byte[] levels = bidiBase.levels;
            int n = 126;
            int trailingWSStart = bidiBase.trailingWSStart;
            int runCount = 0;
            for (int i = 0; i < trailingWSStart; ++i) {
                if (levels[i] != n) {
                    ++runCount;
                    n = levels[i];
                }
            }
            if (runCount == 1 && trailingWSStart == length) {
                getSingleRun(bidiBase, levels[0]);
            }
            else {
                int paraLevel = 62;
                int n2 = 0;
                if (trailingWSStart < length) {
                    ++runCount;
                }
                bidiBase.getRunsMemory(runCount);
                BidiRun[] runsMemory = bidiBase.runsMemory;
                int n3 = 0;
                int j = 0;
                do {
                    int n4 = levels[j];
                    if (n4 < paraLevel) {
                        paraLevel = n4;
                    }
                    if (n4 > n2) {
                        n2 = n4;
                    }
                    while (++j < trailingWSStart && levels[j] == n4) {}
                    runsMemory[n3] = new BidiRun(j, j - j, (byte)n4);
                    ++n3;
                } while (j < trailingWSStart);
                if (trailingWSStart < length) {
                    runsMemory[n3] = new BidiRun(trailingWSStart, length - trailingWSStart, bidiBase.paraLevel);
                    if (bidiBase.paraLevel < paraLevel) {
                        paraLevel = bidiBase.paraLevel;
                    }
                }
                bidiBase.runs = runsMemory;
                bidiBase.runCount = runCount;
                reorderLine(bidiBase, (byte)paraLevel, (byte)n2);
                int n5 = 0;
                for (int k = 0; k < runCount; ++k) {
                    runsMemory[k].level = levels[runsMemory[k].start];
                    BidiRun bidiRun = runsMemory[k];
                    int limit = bidiRun.limit + n5;
                    bidiRun.limit = limit;
                    n5 = limit;
                }
                if (n3 < runCount) {
                    n3 = (((bidiBase.paraLevel & 0x1) != 0x0) ? 0 : n3);
                    runsMemory[n3].level = bidiBase.paraLevel;
                }
            }
        }
        if (bidiBase.insertPoints.size > 0) {
            for (int l = 0; l < bidiBase.insertPoints.size; ++l) {
                BidiBase.Point point = bidiBase.insertPoints.points[l];
                BidiRun bidiRun2 = bidiBase.runs[getRunFromLogicalIndex(bidiBase, point.pos)];
                bidiRun2.insertRemove |= point.flag;
            }
        }
        if (bidiBase.controlCount > 0) {
            for (int n6 = 0; n6 < bidiBase.length; ++n6) {
                if (BidiBase.IsBidiControlChar((int)bidiBase.text[n6])) {
                    BidiRun bidiRun3 = bidiBase.runs[getRunFromLogicalIndex(bidiBase, n6)];
                    --bidiRun3.insertRemove;
                }
            }
        }
        return;
    }
    
    static int[] prepareReorder(byte[] array, byte[] array2, byte[] array3) {
        if (array == null || array.length <= 0) {
            return null;
        }
        int n = 62;
        int n2 = 0;
        int i = array.length;
        while (i > 0) {
            int n3 = array[--i];
            if (n3 > 62) {
                return null;
            }
            if (n3 < n) {
                n = n3;
            }
            if (n3 <= n2) {
                continue;
            }
            n2 = n3;
        }
        array2[0] = n;
        array3[0] = n2;
        int[] array4 = new int[array.length];
        for (int j = array.length; j > 0; --j, array4[j] = j) {}
        return array4;
    }
    
    static int[] reorderVisual(byte[] array) {
        byte[] array2 = { 0 };
        byte[] array3 = { 0 };
        int[] prepareReorder = prepareReorder(array, array2, array3);
        if (prepareReorder == null) {
            return null;
        }
        int n = array2[0];
        int i = array3[0];
        if (n == i && (n & 0x1) == 0x0) {
            return prepareReorder;
        }
        do {
            int j = 0;
            while (true) {
                if (j < array.length && array[j] < i) {
                    ++j;
                }
                else {
                    if (j >= array.length) {
                        break;
                    }
                    while (++j < array.length && array[j] >= i) {}
                    for (int n2 = j - 1; j < n2; ++j, --n2) {
                        int n3 = prepareReorder[j];
                        prepareReorder[j] = prepareReorder[n2];
                        prepareReorder[n2] = n3;
                    }
                    if (j == array.length) {
                        break;
                    }
                    ++j;
                }
            }
            i = (byte)(i - 1);
        } while (i >= (byte)(n | 0x1));
        return prepareReorder;
    }
    
    static int[] getVisualMap(BidiBase bidiBase) {
        BidiRun[] runs = bidiBase.runs;
        int n = (bidiBase.length > bidiBase.resultLength) ? bidiBase.length : bidiBase.resultLength;
        int[] array = new int[n];
        int n2 = 0;
        int n3 = 0;
        for (int i = 0; i < bidiBase.runCount; ++i) {
            int start = runs[i].start;
            int limit = runs[i].limit;
            if (runs[i].isEvenRun()) {
                do {
                    array[n3++] = start++;
                } while (++n2 < limit);
            }
            else {
                int n4 = start + (limit - n2);
                do {
                    array[n3++] = --n4;
                } while (++n2 < limit);
            }
        }
        if (bidiBase.insertPoints.size > 0) {
            int n9 = 0;
            int runCount2 = bidiBase.runCount;
            BidiRun[] runs3 = bidiBase.runs;
            for (int n10 = 0; n10 < runCount2; ++n10) {
                int insertRemove2 = runs3[n10].insertRemove;
                if ((insertRemove2 & 0x5) > 0) {
                    ++n9;
                }
                if ((insertRemove2 & 0xA) > 0) {
                    ++n9;
                }
            }
            int resultLength = bidiBase.resultLength;
            for (int n11 = runCount2 - 1; n11 >= 0 && n9 > 0; --n11) {
                int insertRemove3 = runs3[n11].insertRemove;
                if ((insertRemove3 & 0xA) > 0) {
                    array[--resultLength] = -1;
                    --n9;
                }
                for (int n12 = (n11 > 0) ? runs3[n11 - 1].limit : 0, n13 = runs3[n11].limit - 1; n13 >= n12 && n9 > 0; --n13) {
                    array[--resultLength] = array[n13];
                }
                if ((insertRemove3 & 0x5) > 0) {
                    array[--resultLength] = -1;
                    --n9;
                }
            }
        }
        else if (bidiBase.controlCount > 0) {
            int runCount = bidiBase.runCount;
            BidiRun[] runs2 = bidiBase.runs;
            int j = 0;
            int n5 = 0;
            int n6;
            for (int k = 0; k < runCount; ++k, j += n6) {
                n6 = runs2[k].limit - j;
                int insertRemove = runs2[k].insertRemove;
                if (insertRemove == 0 && n5 == j) {
                    n5 += n6;
                }
                else if (insertRemove == 0) {
                    int limit2;
                    for (limit2 = runs2[k].limit, ; j < limit2; ++j) {
                        array[n5++] = array[j];
                    }
                }
                else {
                    int start2 = runs2[k].start;
                    int evenRun = runs2[k].isEvenRun();
                    int n7 = start2 + n6 - 1;
                    for (int l = 0; l < n6; ++l) {
                        int n8 = evenRun ? (start2 + l) : (n7 - l);
                        if (!BidiBase.IsBidiControlChar((int)bidiBase.text[n8])) {
                            array[n5++] = n8;
                        }
                    }
                }
            }
        }
        if (n == bidiBase.resultLength) {
            return array;
        }
        int[] array2 = new int[bidiBase.resultLength];
        System.arraycopy(array, 0, array2, 0, bidiBase.resultLength);
        return array2;
    }
}
